#ifndef _ReplicationDlg_CPP
#define _ReplicationDlg_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <CommCtrl.h>

#include "../Resources/Resource.H"

#include "../CSockSrvr/CSockSrvr.H"

#include "../../SharedClasses/CStatusDlg/CStatusDlg.H"
#include "../../SharedSource/NSWFL.H"

#include "../Source/Entry.H"
#include "../Source/Routines.H"
#include "../Source/Replication.H"
#include "../../SharedSource/Common.H"

#include "../Dialogs/MainDlg.H"
#include "../Dialogs/SplashDlg.H"
#include "../Dialogs/ReplicationDlg.H"
#include "../Dialogs/RepIssues.H"
#include "../Dialogs/PendingTrans.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

//---------------------(Variable Declarations)
WNDPROC gpOldReplicationListProc;

HWND Replication_hWnd = NULL;

HWND TablesList_hWnd = NULL;

bool bProcessing = false;

DWORD WINAPI ProcessTablesGrid_Thread(LPVOID lpData);
HANDLE ProcessTablesGrid_Thread_Handle = NULL;
DWORD ProcessTablesGrid_Thread_ID = 0;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

BOOL CALLBACK ReplicationDialog(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    //--------------------------------------------------------------------------

	static HIMAGELIST hImgList;

    //--------------------------------------------------------------------------

    if(uMsg == WM_INITDIALOG)
    {
        Replication_hWnd = hWnd;

        char sCaption[1024];
		sprintf(sCaption, "%s :: %s", gsTitleCaption, "Replication");
        SendMessage(hWnd, (UINT)WM_SETTEXT, (WPARAM)0, (LPARAM)sCaption);
        SendMessage(hWnd, WM_SETICON, TRUE, (LPARAM) LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_TRAYICON)) );

		LV_COLUMN MyLVColumb;
		memset(&MyLVColumb, 0, sizeof(MyLVColumb));

		TablesList_hWnd = GetDlgItem(hWnd, IDC_TALBES);

        gpOldReplicationListProc = (WNDPROC) SetWindowLong(TablesList_hWnd, GWL_WNDPROC, (long) &ReplicationListProc);

		// Create Listview columbs
        MyLVColumb.cx        = 150;
        MyLVColumb.pszText   = "Database";
        MyLVColumb.iSubItem  = 0;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(TablesList_hWnd, 0, &MyLVColumb);

        MyLVColumb.cx        = 250;
        MyLVColumb.pszText   = "Table Name";
        MyLVColumb.iSubItem  = 1;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(TablesList_hWnd, 1, &MyLVColumb);

        MyLVColumb.cx        = 0;
        MyLVColumb.pszText   = "Primary Key";
        MyLVColumb.iSubItem  = 2;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(TablesList_hWnd, 2, &MyLVColumb);

        MyLVColumb.cx        = 300;
        MyLVColumb.pszText   = "Status";
        MyLVColumb.iSubItem  = 3;
        MyLVColumb.mask      = LVCF_WIDTH | LVCF_TEXT | LVCF_SUBITEM;
        MyLVColumb.fmt       = LVCFMT_LEFT;
        ListView_InsertColumn(TablesList_hWnd, 3, &MyLVColumb);

		hImgList = ImageList_Create(GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), TRUE, 1, 1);

		HICON hIcon = NULL;
		
        hIcon = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_AVAILFORREP));
        ImageList_AddIcon(hImgList, (HICON)hIcon);
        DeleteObject((HICON)hIcon);

        hIcon = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_NOTAVAILFORREP));
        ImageList_AddIcon(hImgList, (HICON)hIcon);
        DeleteObject((HICON)hIcon);

        hIcon = LoadIcon(ghAppInstance, MAKEINTRESOURCE(IDI_REPLICATING));
        ImageList_AddIcon(hImgList, (HICON)hIcon);
        DeleteObject((HICON)hIcon);

        ListView_SetImageList(TablesList_hWnd, hImgList, LVSIL_SMALL);

		ShowWindow(MainDialog_hWnd, SW_HIDE);
		PopTablesGrid(TablesList_hWnd);
		ShowWindow(MainDialog_hWnd, SW_SHOW);

		CenterWindow(hWnd);

        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_COMMAND)
    {
		if(wParam == ID_REPLICATION_SELECTALL)
        {
			CheckGridRows(TablesList_hWnd, true);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_DESELECTALL)
        {
			CheckGridRows(TablesList_hWnd, false);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_SELECTALLOFTHISDATABASE)
        {
			CheckGridDatabaseRows(TablesList_hWnd, true);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_DESELECTALLOFTHISDATABASE)
        {
			CheckGridDatabaseRows(TablesList_hWnd, false);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_SELECTALLHIGHLIGHTED)
        {
			CheckGridHighlightedRows(TablesList_hWnd, true);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_DESELECTALLHIGHLIGHTED)
        {
			CheckGridHighlightedRows(TablesList_hWnd, false);
			return TRUE;
		}

		if(wParam == ID_REPLICATION_CANCEL)
        {
			return TRUE;
		}

		if(wParam == ID_PENDINGTRANSACTIONS)
        {
			DialogBox(ghAppInstance, MAKEINTRESOURCE(IDD_PENDINGTRANS), hWnd, PendingTransDialog);
			return TRUE;
		}

		if(wParam == ID_CHKALL)
        {
			CheckGridRows(TablesList_hWnd, true);
			return TRUE;
		}

        if(wParam == ID_CHKNONE)
        {
			CheckGridRows(TablesList_hWnd, false);
			return TRUE;
		}

		if(wParam == ID_APPLY)
        {
			bProcessing = true;
			ProcessTablesGrid_Thread_Handle = CreateThread(NULL, 0 ,ProcessTablesGrid_Thread, (LPVOID)0, 0, &ProcessTablesGrid_Thread_ID);

			int iLVStyle = LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT;
			SendMessage(TablesList_hWnd, (UINT)LVM_SETEXTENDEDLISTVIEWSTYLE, (WPARAM)0, (LPARAM)iLVStyle);

			return TRUE;
        }

        if(wParam == ID_CANCEL)
        {
			EndDialog(hWnd,0);
			DestroyWindow(hWnd);
			return TRUE;
        }
		
		return FALSE;
    }

	//--------------------------------------------------------------------------

	if(uMsg == WM_PAINT)
    {
        HDC ThisHDC;
        PAINTSTRUCT ThisPS;

        ThisHDC = BeginPaint(hWnd, &ThisPS);

        // Any painting should be done here

        EndPaint(hWnd, &ThisPS);
        return TRUE;
    }

    //--------------------------------------------------------------------------

    if(uMsg == WM_CLOSE) 
    {
        if(bProcessing)
		{
			MessageBox(hWnd, "Please wait until the process is complete.", gsTitleCaption, NULL);
		}
		else{
			EndDialog(hWnd,0);
			DestroyWindow(hWnd);
		}
        return TRUE;
    }

    //--------------------------------------------------------------------------

    return FALSE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK ReplicationListProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	LRESULT lResult = CallWindowProc(gpOldReplicationListProc, hWnd, uMsg, wParam, lParam);

	if(uMsg == WM_RBUTTONDOWN)
    {
		int iSelected =  ListView_GetSelectedCount(hWnd);

		// Load menu
    	HMENU hMenu = LoadMenu(ghAppInstance, MAKEINTRESOURCE(IDR_REPLICATIONLIST) );
   		hMenu = GetSubMenu(hMenu, 0);

		if(iSelected > 1)
		{
			//EnableMenuItem(hMenu, ID_REPLICATION_SELECTALL, MF_ENABLED);
			//EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALL, MF_ENABLED);
			//EnableMenuItem(hMenu, ID_REPLICATION_SELECTALLOFTHISDATABASE, MF_ENABLED);
			//EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALLOFTHISDATABASE, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_SELECTALLHIGHLIGHTED, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALLHIGHLIGHTED, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_CANCEL, MF_ENABLED);
		}
		else{
			EnableMenuItem(hMenu, ID_REPLICATION_SELECTALL, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALL, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_SELECTALLOFTHISDATABASE, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALLOFTHISDATABASE, MF_ENABLED);
			//EnableMenuItem(hMenu, ID_REPLICATION_SELECTALLHIGHLIGHTED, MF_ENABLED);
			//EnableMenuItem(hMenu, ID_REPLICATION_DESELECTALLHIGHLIGHTED, MF_ENABLED);
			EnableMenuItem(hMenu, ID_REPLICATION_CANCEL, MF_ENABLED);
		}

        POINT xy;
        GetCursorPos(&xy);
        TrackPopupMenuEx(hMenu, TPM_LEFTALIGN|TPM_RIGHTBUTTON, (xy.x) + 1, xy.y, Replication_hWnd, NULL);
        DestroyMenu(hMenu);
    }

    return lResult;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckGridHighlightedRows(HWND Grid_hWnd, bool bCheck)
{
	int iItem = -1;

	while((iItem = ListView_GetNextItem(Grid_hWnd, iItem, LVNI_SELECTED)) != -1)
	{
		ListView_SetCheckState(Grid_hWnd, iItem, (BOOL) bCheck);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckGridDatabaseRows(HWND Grid_hWnd, bool bCheck)
{
	char sDatabase[1024];
	char sText[1024];
	int iItem = -1;

	iItem = ListView_GetNextItem(Grid_hWnd, iItem, LVNI_SELECTED);

	if(iItem != -1)
	{
		ListView_GetItemText(Grid_hWnd, iItem, 0, sDatabase, sizeof(sDatabase));

		iItem = -1;
		
		while((iItem = ListView_GetNextItem(Grid_hWnd, iItem, LVNI_ALL)) != -1)
		{
			ListView_GetItemText(Grid_hWnd, iItem, 0, sText, sizeof(sText));

			if(strcmpi(sDatabase, sText) == 0)
			{
				ListView_SetCheckState(Grid_hWnd, iItem, (BOOL) bCheck);
			}
			
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CheckGridRows(HWND Grid_hWnd, bool bCheck)
{
	int iRow = 0;
	int iItems = ListView_GetItemCount(Grid_hWnd);

	while(iRow < iItems)
    {
		ListView_SetCheckState(Grid_hWnd, iRow, (BOOL) bCheck);
		iRow++;
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool PopTablesGrid(HWND Grid_hWnd)
{
	int iRow = 0;
	int iItem = 0;
	int iTempSz = 0;
	int iChecked = 0;
	int iImage = 0;
	bool bGotPK = true;

	char sDatabase[255];
	char sTemp[5120];
	char sSQL[5120];

	CSQL cSQL;
	CRecordSet rsDatabases;
	CRecordSet rsTemp;

	LV_ITEM MyLVItem;
	memset(&MyLVItem, 0, sizeof(MyLVItem));

    int iLVStyle = LVS_EX_GRIDLINES | LVS_EX_FULLROWSELECT | LVS_EX_CHECKBOXES;
    SendMessage(Grid_hWnd, (UINT)LVM_SETEXTENDEDLISTVIEWSTYLE, (WPARAM)0, (LPARAM)iLVStyle);

	if(!cSQL.Connect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, "Master"))
	{
		MessageBox(MainDialog_hWnd, "Failed to connect to the SQL server.", gsTitleCaption, NULL);
		return false;
	}
	
	CStatusDlg MyStatDlg;

	MyStatDlg.Load(NULL, "Please wait...", IDI_MAIN, false);
	EnableWindow(Replication_hWnd, FALSE);
	MyStatDlg.Show();

	strcpy(sSQL, "SELECT Name FROM SysDatabases"
		" WHERE Name NOT LIKE 'SQLExch_%'"
		" AND Name NOT IN ('Master', 'Model', 'MSDB', 'TempDB')"
		" ORDER BY Name");
	cSQL.Execute(sSQL, &rsDatabases);	

	while(rsDatabases.Fetch())
	{
		rsDatabases.sColumnEx(1, sDatabase, sizeof(sDatabase), &iTempSz);

		sprintf(sTemp, "Retrieving SQL Resources. [%s]", sDatabase);
		MyStatDlg.SetText(sTemp);

		strcpy(sTemp, "SELECT '%s' as [DB], A.ID, A.Name,"
			" IsNull((SELECT top 1 InSysObjects.Name"
			" FROM"
			" [%s].[%s].SysObjects as InSysObjects,"
			" [%s].[%s].SysIndexes as InSysIndexes,"
			" [%s].[%s].SysIndexKeys as InSysIndexKeys"
			" WHERE InSysObjects.xtype = 'PK'"
			" AND InSysObjects.Name = InSysIndexes.Name AND InSysIndexes.IndId = InSysIndexKeys.IndId"
			" AND InSysIndexes.ID = InSysIndexKeys.ID"
			" AND InSysObjects.Parent_Obj = A.ID), ''),"
			" Count(B.ID)"
			" FROM [%s].[%s].SysObjects AS A, [%s].[%s].SysObjects AS B"
			" WHERE A.xType = 'U' AND LEFT(A.NAME, 8) <> 'SQLExch_' AND A.ID *= B.Parent_Obj"
			" AND LEFT(B.NAME, 8) = 'SQLExch_' AND A.Name <> 'dtProperties'"
			" GROUP BY A.Name, A.ID, A.CrDate, A.RefDate"
			" ORDER BY A.Name");

		sprintf(sSQL, sTemp, sDatabase, sDatabase, gsDefaultDBO, sDatabase, gsDefaultDBO,
			sDatabase, gsDefaultDBO, sDatabase, gsDefaultDBO,
			sDatabase, gsDefaultDBO, sDatabase, gsDefaultDBO);

		cSQL.Execute(sSQL, &rsTemp);

		iRow = 0;

		MyStatDlg.SetProgressRange(0, rsTemp.RowCount);

		sprintf(sTemp, "Loading SQL Resources. [%s]", sDatabase);
		MyStatDlg.SetText(sTemp);
		
		while(rsTemp.Fetch())
		{
			MyLVItem.pszText  = sDatabase;
			MyLVItem.mask     = LVIF_TEXT;
			MyLVItem.iSubItem = 0;
			MyLVItem.iItem    = iItem;
			ListView_InsertItem(Grid_hWnd, &MyLVItem);

			rsTemp.sColumnEx(3, sTemp, sizeof(sTemp), &iTempSz);
			MyLVItem.pszText  = sTemp;
			MyLVItem.mask     = LVIF_TEXT;
			MyLVItem.iSubItem = 1;
			MyLVItem.iItem    = iItem;
			ListView_SetItem(Grid_hWnd, &MyLVItem);

			rsTemp.sColumnEx(4, sTemp, sizeof(sTemp), &iTempSz);
			MyLVItem.pszText  = sTemp;
			MyLVItem.mask     = LVIF_TEXT;
			MyLVItem.iSubItem = 2;
			MyLVItem.iItem    = iItem;
			ListView_SetItem(Grid_hWnd, &MyLVItem);

			if(strlen(sTemp) > 0)
			{
				bGotPK = true;
			}
			else {
				bGotPK = false;
			}

			if(rsTemp.lColumn(5) > 0)
			{
				ListView_SetCheckState(Grid_hWnd, iItem, TRUE);
				iChecked = 1;
			}
			else{
				ListView_SetCheckState(Grid_hWnd, iItem, FALSE);
				iChecked = 0;
			}

			if(iChecked == 1) {
				strcpy(sTemp, "Replicating.");
				iImage = 2;
			}
			else if(bGotPK) {
				strcpy(sTemp, "Not Replicating.");
				iImage = 0;
			}
			else{
				strcpy(sTemp, "Cannot Replicate.");
				iImage = 1;
			}

			MyLVItem.mask = LVIF_PARAM|LVIF_IMAGE;
			MyLVItem.iSubItem = 0;
			MyLVItem.iImage   = iImage;
			MyLVItem.lParam   = iImage;
			MyLVItem.iItem    = iItem;
			ListView_SetItem(Grid_hWnd, &MyLVItem);

			MyLVItem.pszText  = sTemp;
			MyLVItem.mask     = LVIF_TEXT;
			MyLVItem.iSubItem = 3;
			MyLVItem.iItem    = iItem;
			ListView_SetItem(Grid_hWnd, &MyLVItem);

			iItem++;
			iRow++;

			MyStatDlg.SetProgressPos(iRow);
			Sleep(1);
		}
	}

	MyStatDlg.SetText("Loading SQL resources complete!");

	MyStatDlg.SetButtonText("Ok");

	EnableWindow(Replication_hWnd, TRUE);

	MyStatDlg.EnableButton();

	while(MyStatDlg.IsDlgVisible())
	{
		Sleep(1);
	}

	MyStatDlg.Unload();

	cSQL.Disconnect();

	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI ProcessTablesGrid_Thread(LPVOID lpData)
{
	HWND CmdApply_hWnd = GetDlgItem(Replication_hWnd, ID_APPLY);
	HWND CmdClose_hWnd = GetDlgItem(Replication_hWnd, ID_CANCEL);
	HWND CmdAll_hWnd = GetDlgItem(Replication_hWnd, ID_CHKALL);
	HWND CmdNone_hWnd = GetDlgItem(Replication_hWnd, ID_CHKNONE);

	EnableWindow(CmdApply_hWnd, FALSE);
	EnableWindow(CmdClose_hWnd, FALSE);
	EnableWindow(CmdAll_hWnd, FALSE);
	EnableWindow(CmdNone_hWnd, FALSE);

	ProcessTablesGrid(TablesList_hWnd);

	EnableWindow(CmdClose_hWnd, TRUE);

	bProcessing = false;

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool ProcessTablesGrid(HWND Grid_hWnd)
{
    int iRow = 0;
	int iParam = 0;
	int iTempSz = 0;
	int iItems = ListView_GetItemCount(Grid_hWnd);
	char sTableName[1024];
	char sDatabase[255];
	char sLastDB[255];

	CSQL cSQL;
	CRecordSet rsDatabases;

	CStatusDlg MyStatDlg;

	MyStatDlg.Load(Replication_hWnd, "Creating replications.", IDI_MAIN, false);
	EnableWindow(Replication_hWnd, FALSE);
	MyStatDlg.Show();

	MyStatDlg.SetProgressRange(0, iItems);

	Sleep(1500);

	MyStatDlg.SetText("Updating replication settings.");

	while(iRow < iItems)
    {
		ListView_GetItemText(Grid_hWnd, iRow, 0, sDatabase, sizeof(sDatabase));
		ListView_GetItemText(Grid_hWnd, iRow, 1, sTableName, sizeof(sTableName));

		if(strcmpi(sDatabase, sLastDB) != 0)
		{
			if(strlen(sLastDB) > 0)
			{
				cSQL.Disconnect();
			}
			
			if(!cSQL.Connect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, sDatabase))
			{
				MessageBox(Replication_hWnd, "Failed to connect to the SQL server.", gsTitleCaption, NULL);
				return false;
			}
			strcpy(sLastDB, sDatabase);
		}

		/*
			lParam:
				0: Not (But Can) replicating.
				1: Cannot replicate.
				2: Currently replicating.
		*/
		iParam = GetListItemlParam(Grid_hWnd, iRow, 0);

		//If the item is checked.
		if(ListView_GetCheckState(Grid_hWnd, iRow))
		{
			//If the item was previously unchecked.
			if(iParam == 0)
			{
				if(CreateReplicationEx(&cSQL, gsReplicationDB, sDatabase, gsDefaultDBO, sTableName, Grid_hWnd, 3, iRow))
				{
					SetStatus(Grid_hWnd, 3, iRow, "Create OK.");
				}
				else SetStatus(Grid_hWnd, 3, iRow, "Create Failed!");
			}
		}
		else { //If the item is unchecked.

			//If the item was previously checked.
			if(iParam == 2)
			{
				SetStatus(Grid_hWnd, 3, iRow, "Dropping Triggers.");
				if(DropReplicationTriggers(&cSQL, sDatabase, sTableName))
				{
					SetStatus(Grid_hWnd, 3, iRow, "Dropping tables.");
					if(DropReplicationTables(&cSQL, gsReplicationDB, sDatabase, gsDefaultDBO, sTableName))
					{
						SetStatus(Grid_hWnd, 3, iRow, "Drop OK.");
					}
					else SetStatus(Grid_hWnd, 3, iRow, "Drop Failed!");
				}
				else SetStatus(Grid_hWnd, 3, iRow, "Drop Failed!");
			}
		}

        iRow++;

		MyStatDlg.SetProgressPos(iRow);
		Sleep(1);
    }

	if(strlen(sLastDB) > 0)
	{
		cSQL.Disconnect();
	}

	if(!cSQL.Connect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, "Master"))
	{
		MessageBox(Replication_hWnd, "Failed to connect to the SQL server.", gsTitleCaption, NULL);
		return false;
	}

	GenerateReplicationScripts(&MyStatDlg, gsReplicationDB, gsDefaultDBO, true);
			
	MyStatDlg.SetText("Complete.");

	MyStatDlg.SetButtonText("Ok");

	MyStatDlg.EnableButton();

	EnableWindow(Replication_hWnd, TRUE);

	while(MyStatDlg.IsDlgVisible())
	{
		Sleep(1);
	}

	MyStatDlg.Unload();

	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif

