#ifndef _ROUTINES_H
#define _ROUTINES_H
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define MAX_AUTH_LENGTH 1024 //Max size of the string used for authentication
#define MAX_KEY_LENGTH  1024 //Max size of the encryption key. (Both Registry & Generated)

#define FILEBUFFERSZ    4000

#define EVENT_NONE  0
#define EVENT_INFO  1
#define EVENT_WARN  2
#define EVENT_ERROR 3

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool SaveRegistryValues(void);
bool GetRegistryValues(void);
bool WaitOnApplicationToExit(void);
bool ConnectToServer(void);
int CmdCmp(const char *sBuf, const char *sCmd);
int BreakCmdFromData(const char *sBuf, int iCmdLen, int iBufSz, char *sOutBuf);
int AppendDataToCmd(const char *sCmd, char *sData, int iDataSz, char *sOutBuf);

bool OpenLogFile(void);
bool CloseLogFile(void);
void WriteAnEvent(const char *sMessage, int iEventType);
void WriteSysLogEx(const char *sMessage, int iEventType);
void WriteSysLog(const char *sMessage);
void WriteLogEx(int iClientId, const char *sMessage, int iEventType);
void WriteLog(int iClientId, const char *sMessage);

bool GetIPAddress(char *InputAddr, char *OutAddr);
char *ResolveHost(char *xHostName, int AddressNum);
void SetStatus(HWND Grid_hWnd, int iCol, int iItem, char *sText);
bool IsAtleastOneDaySelected(void);
int GetNextRunDay(int iToday);

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

DWORD WINAPI Timer_Thread(LPVOID);

extern const char *gsWeekDayName[];

extern bool gbWeekDays[7];

extern char gsSessionLogDir[MAX_PATH];
extern char sTempFilesPath[MAX_PATH];
extern char gsPath[MAX_PATH];
extern char gsServerAddress[255];
extern char gsAuthKey[MAX_AUTH_LENGTH];
extern char gsAuthString[MAX_AUTH_LENGTH];

extern char gsCompanyName[64];
extern char gsCompanyPassword[64];

extern char gsSQLDataFiles[MAX_PATH]; // Relative to server.
extern char gsDefaultDBO[255];
extern char gsReplicationDB[255];

extern char gsSQLDriver[255];
extern char gsSQLPassword[255];
extern char gsSQLServer[255];
extern char gsSQLUserID[255];

extern bool gbShowSplashScreen;
extern bool gbKillApplication;
extern bool gbApplicationRunning;
extern bool gbConnectNow;
extern bool gbRunningAsService;
extern bool gbThrowSQLErrors;
extern bool gbReplaceSngleQteSQLData;
extern bool gbRTrimSQLData;
extern bool gbDropBadPackets;
extern bool gbPacketMode;
extern bool gbAutoConnect;
extern bool gbCacheLogFile;

extern int giMaxClients;
extern int giServerPort;
extern int giPingTimeoutMS;
extern int giTotalConnects;
extern int giWarningCount;
extern int giErrorCount;
extern int giNextDay;			 // The day on which the next connection will occur.

extern DWORD gdwStartTime;		 // The beginning of the connection time window.
extern DWORD gdwStopTime;		 // The End of the connection time window.
extern DWORD gdwNextTime;		 // The time at which the next connection will occur.
extern DWORD gdwConnectInterval; // The interval on which each connection will occur.

extern DWORD Timer_Thread_ID;

extern HANDLE Timer_Thread_Handle;

extern FILE *gfhSessionLog;

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
#endif
